/****************************************************************************
**
** Copyright (C) 2011 Digia Plc
** All rights reserved.
** For any questions to Digia, please use contact form at http://qt.digia.com
**
** This file is part of the QtDeclarative module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE$
** Licensees holding valid Qt Commercial licenses may use this file in
** accordance with the Qt Commercial License Agreement provided with the 
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  
**
** If you have questions regarding the use of this file, please use
** contact form at http://qt.digia.com
** $QT_END_LICENSE$
** 
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
****************************************************************************/

#ifndef QDECLARATIVESCRIPTSTRING_H
#define QDECLARATIVESCRIPTSTRING_H

#include <QtCore/qstring.h>
#include <QtCore/qshareddata.h>
#include <QtCore/qmetatype.h>

QT_BEGIN_HEADER

QT_BEGIN_NAMESPACE

QT_MODULE(Declarative)

class QObject;
class QDeclarativeContext;
class QDeclarativeScriptStringPrivate;
class Q_DECLARATIVE_EXPORT QDeclarativeScriptString 
{
public:
    QDeclarativeScriptString();
    QDeclarativeScriptString(const QDeclarativeScriptString &);
    ~QDeclarativeScriptString();

    QDeclarativeScriptString &operator=(const QDeclarativeScriptString &);

    QDeclarativeContext *context() const;
    void setContext(QDeclarativeContext *);

    QObject *scopeObject() const;
    void setScopeObject(QObject *);

    QString script() const;
    void setScript(const QString &);

private:
    QSharedDataPointer<QDeclarativeScriptStringPrivate> d;
};

QT_END_NAMESPACE

Q_DECLARE_METATYPE(QDeclarativeScriptString)

QT_END_HEADER

#endif // QDECLARATIVESCRIPTSTRING_H

